#!/usr/bin/perl
use Test::Simple tests => 7;

use RPM::VersionCompare qw(labelSplit);

# First three elements are reference, next three are tested value. Each
# triplet is compound of epoch, version, release order.
# Return true if they match.
sub check {
    my ($eo, $vo, $ro, $ei, $vi, $ri) = @_;
    if (!defined $eo) {
        if (defined ($ri // $vi // $ri)) {
            return 0;
        } else {
            return 1;
        }
    }

    if (($eo eq $ei) and ($vo eq $vi) and ($ro eq $ri)) {
        return 1;
    } else {
        return 0;
    }
}

ok(check('a', 'b', 'c',     labelSplit('a:b-c')),           'a:b-c');
ok(check(0, 'b', 'c',       labelSplit('b-c')),             'b-c');
ok(check('a', 'b', 0,       labelSplit('a:b')),             'a:b');
ok(check(0, 'b', 0,         labelSplit('b')),               'b');
ok(check(4, '5.12.0', 140,  labelSplit('4:5.12.0-140')),    '4:5.12.0-140');
ok(check(0, '1.0', 0,       labelSplit('1.0')),             '1.0');
ok(check('49', '5.12.0', '140', labelSplit('49:5.12.0-140')), '49:5.12.0-140');

